您的位置:首页 > 其它

HDU 2614 Beat

2015-03-25 21:26 288 查看
Problem Description

Zty is a man that always full of enthusiasm. He wants to solve every kind of difficulty ACM problem in the world. And he has a habit that he does not like to solve

a problem that is easy than problem he had solved. Now yifenfei give him n difficulty problems, and tell him their relative time to solve it after solving the other one.

You should help zty to find a order of solving problems to solve more difficulty problem.

You may sure zty first solve the problem 0 by costing 0 minute. Zty always choose cost more or equal time’s problem to solve.



Input

The input contains multiple test cases.

Each test case include, first one integer n ( 2< n < 15).express the number of problem.

Than n lines, each line include n integer Tij ( 0<=Tij<10), the i’s row and j’s col integer Tij express after solving the problem i, will cost Tij minute to solve the problem j.



Output

For each test case output the maximum number of problem zty can solved.



Sample Input

3
0 0 0
1 0 1
1 0 0
3
0 2 2
1 0 1
1 1 0
5
0 1 2 3 1
0 0 2 3 1
0 0 0 3 1
0 0 0 0 2
0 0 0 0 0




Sample Output

3
2
4
Hint
Hint: sample one, as we know zty always solve problem 0 by costing 0 minute. 
So after solving problem 0, he can choose problem 1 and problem 2, because T01 >=0 and T02>=0. 
But if zty chooses to solve problem 1, he can not solve problem 2, because T12 < T01. 
So zty can choose solve the problem 2 second, than solve the problem 1.  

题意:矩阵,固定从a[0][0]出发,到达第0行,然后再选择第一行的任意一个,但是你能解出a[i][j]题的条件是你必须做出第a[k][i]题,并且a[k][i]题所花的时间要小于等于第ij题所花的时间
思路:直接DFS了
#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;

int a[16][16];
int vis[16];
int n,maxn;

void dfs(int u,int r,int val)
{
    maxn=max(r,maxn);
    if(maxn==n)
        return ;
    for(int i=1;i<n;i++)
    {
        if(vis[i])
            continue;
        if(val<=a[u][i])
        {
            vis[i]=1;
            dfs(i,r+1,a[u][i]);
            vis[i]=0;
        }
    }
}

int main()
{
    while(scanf("%d",&n)!=EOF)
    {
        int i,j;
        for(i=0;i<n;i++)
        {
            for(j=0;j<n;j++)
                scanf("%d",&a[i][j]);
        }
        memset(vis,0,sizeof(vis));
        maxn=0;
        for(i=1;i<n;i++)
        {
            vis[i]=1;
            dfs(i,2,a[0][i]);   //因为绝对能做出00题,并且能做出第0行的任意题
            //所以直接枚举其他的行了,并且绝对能做出前2题
            vis[i]=0;
        }
        printf("%d\n",maxn);

    }
    return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: